<?php

namespace Pinpoint\TrustArc\ViewModel;

use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\View\Element\Block\ArgumentInterface;
use Magento\Store\Model\ScopeInterface;

class Consent implements ArgumentInterface
{
    /**
     * @var ScopeConfigInterface
     */
    private ScopeConfigInterface $scopeInterface;
    private const TRUSTARC_CONFIG_PATH = "trustarc/general/";

    /**
     * Constructor
     * @param ScopeConfigInterface $scopeInterface
     */
    public function __construct(
        ScopeConfigInterface  $scopeInterface
    ) {
        $this->scopeInterface = $scopeInterface;
    }

    /**
     * Get Config value
     * @param string $param
     * @return string
     */
    private function getConfig(string $param): string
    {
        return $this->scopeInterface->getValue(self::TRUSTARC_CONFIG_PATH . $param, ScopeInterface::SCOPE_STORE);
    }

    /**
     * Get URL
     * @return string
     */
    public function getUrl(): string
    {
        if ($this->getConfig("enabled")) {
            $textDisplay = $this->getConfig("text") ? "true" : "false";
            $queryParams = http_build_query([
                'domain' => $this->getConfig("domain"),
                'c' => $this->getConfig("cparam"),
                'js' => $this->getConfig("jsparam"),
                'noticeType' => $this->getConfig("notice_type"),
                'text' => $textDisplay,
                'gtm' => $this->getConfig("gtmparam")
            ]);
            return 'https://consent.trustarc.com/notice?' . $queryParams;
        }
        return "";
    }
}
